commit:     3573843ade094597bc985e0641d9144c1e74c5b2
Author:     Sam James <sam <AT> gentoo <DOT> org>
AuthorDate: Sat Dec 18 08:05:11 2021 +0000
Commit:     Sam James <sam <AT> gentoo <DOT> org>
CommitDate: Sat Dec 18 08:05:11 2021 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=3573843a

sys-cluster/mpich: add 3.4.3

Signed-off-by: Sam James <sam <AT> gentoo.org>

 sys-cluster/mpich/Manifest           |   1 +
 sys-cluster/mpich/mpich-3.4.3.ebuild | 163 +++++++++++++++++++++++++++++++++++
 2 files changed, 164 insertions(+)

diff --git a/sys-cluster/mpich/Manifest b/sys-cluster/mpich/Manifest
index 8cba7427970e..51b648126996 100644
--- a/sys-cluster/mpich/Manifest
+++ b/sys-cluster/mpich/Manifest
@@ -1,3 +1,4 @@
 DIST mpich-3.0.4.tar.gz 10921075 BLAKE2B 
341aaac23277aed05a4448ea03d9caf1ee14cfe327a770c95d620fc1ee1ea7bfa6df36860aa44aad162eb6d630d35fdfb30ae9a866d67680ab71c7b4326c109c
 SHA512 
f9d8b2cf561fe5f85c12512ef4dd7b0cf5ec8b53ddb07bfa0d1db2e3c8ae0382c77e0661f46b82ec96b05d18ea2d25328bb84e9528ac06e5925f30ec8ef030d0
 DIST mpich-3.3.tar.gz 27209008 BLAKE2B 
3010f847456ed71a27e728b91887e04303a83b4abea883bf73d9794ff697052efe3bccd238933dc6e5fbc75e0be36004f1ae9fc7695a4e8887984552ae005917
 SHA512 
1ed6d8d30db4923fd1bd39b6e9622f0db939a45edf8d9f8bdbccfa619fde7fb920c5a0d3f2442f0dd63cf8fda823dbd2983ac5f7c16308bc79e04f61d8e119be
 DIST mpich-3.4.2.tar.gz 32850822 BLAKE2B 
cbbb7d8b3c6db31c9ee8f59e6a386c000480a738819c8b4398e1299c0fdfce28649a3ebc868aa48517476d0b49d4d58e66407f2116708c3d9e61ce43f6e1c32b
 SHA512 
5f5389071c7d275a864df16aedd19f2b925c9b9ad3b304f9c9f99b5808f6b82def775b4191c03cdd3288c5e4478a40a2aae22c3cf2aabe82be1dd612efd7f2a6
+DIST mpich-3.4.3.tar.gz 32853411 BLAKE2B 
889f8d4077cd9e8a727e46431ad505b2a17d7391dec00910254d8dbdbc992e2df92efd355d290881fb3a73966bf3504b6942003f88041669c16a8aa142c2dab2
 SHA512 
d8455a3e7150dc720ba8a0660bfbbec364b62729f4a319928bb910644d20ee68d267baf9e9e2c322540a725e41858b416ed5fff001fb1f6aa45d1c08db8dad1a

diff --git a/sys-cluster/mpich/mpich-3.4.3.ebuild 
b/sys-cluster/mpich/mpich-3.4.3.ebuild
new file mode 100644
index 000000000000..ddaf646f0454
--- /dev/null
+++ b/sys-cluster/mpich/mpich-3.4.3.ebuild
@@ -0,0 +1,163 @@
+# Copyright 1999-2021 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=7
+
+FORTRAN_NEEDED=fortran
+FORTRAN_STANDARD="77 90"
+
+inherit fortran-2 multilib-minimal flag-o-matic
+
+MY_PV=${PV/_/}
+DESCRIPTION="A high performance and portable MPI implementation"
+HOMEPAGE="https://www.mpich.org/";
+SRC_URI="https://www.mpich.org/static/downloads/${PV}/${P}.tar.gz";
+S="${WORKDIR}"/${PN}-${MY_PV}
+
+LICENSE="mpich2"
+SLOT="0"
+KEYWORDS="~amd64 ~arm64 ~hppa ~ppc ~ppc64 ~x86 ~amd64-linux ~x86-linux"
+IUSE="+cxx doc fortran mpi-threads +romio threads"
+REQUIRED_USE="mpi-threads? ( threads )"
+
+COMMON_DEPEND=">=dev-libs/libaio-0.3.109-r5[${MULTILIB_USEDEP}]
+       >=sys-apps/hwloc-2.0.2:=[${MULTILIB_USEDEP}]
+       sys-libs/libunwind:=[${MULTILIB_USEDEP}]
+       romio? ( net-fs/nfs-utils )"
+
+DEPEND="${COMMON_DEPEND}
+       dev-lang/perl
+       sys-devel/libtool"
+RDEPEND="${COMMON_DEPEND}
+       !sys-cluster/mpich2
+       !sys-cluster/openmpi
+       !sys-cluster/nullmpi"
+
+MULTILIB_WRAPPED_HEADERS=(
+       /usr/include/mpicxx.h
+       /usr/include/mpi.h
+       /usr/include/opa_config.h
+)
+
+#PATCHES=(
+#      "${FILESDIR}"/${PN}-3.3-add-external-libdir-parameter.patch
+#)
+
+src_prepare() {
+       default
+
+       # Using MPICHLIB_LDFLAGS doesn't seem to fully work.
+       sed -i 's| *@WRAPPER_LDFLAGS@ *||' \
+               src/packaging/pkgconfig/mpich.pc.in \
+               src/env/*.in \
+               || die
+
+       # Fix m4 files to satisfy lib dir with multilib.
+       #touch -r src/pm/hydra/confdb/aclocal_libs.m4 \
+       #       confdb/aclocal_libs.m4 \
+       #       || die
+       #cp -fp confdb/aclocal_libs.m4 \
+       #       src/pm/hydra/confdb/aclocal_libs.m4 \
+       #       || die
+       #cp -fp confdb/aclocal_libs.m4 \
+       #       src/pm/hydra/mpl/confdb/aclocal_libs.m4 \
+       #       || die
+       #cd src/pm/hydra/mpl; eautoreconf; cd -
+       #cd src/pm/hydra; eautoreconf; cd -
+       #eautoreconf
+}
+
+multilib_src_configure() {
+       # The configure statements can be somewhat confusing, as they
+       # don't all show up in the top level configure, however, they
+       # are picked up in the children directories.  Hence the separate
+       # local vars.
+
+       local c=
+       if use mpi-threads; then
+               # MPI-THREAD requries threading.
+               c="${c} --with-thread-package=pthreads"
+               c="${c} --enable-threads=runtime"
+       else
+               if use threads ; then
+                       c="${c} --with-thread-package=pthreads"
+               else
+                       c="${c} --with-thread-package=none"
+               fi
+               c="${c} --enable-threads=single"
+       fi
+
+       c="${c} --sysconfdir=${EPREFIX}/etc/${PN}"
+
+       # GCC 10 compatibility workaround
+       # bug #725842
+       append-fflags $(test-flags-FC -fallow-argument-mismatch)
+
+       export MPICHLIB_CFLAGS="${CFLAGS}"
+       export MPICHLIB_CPPFLAGS="${CPPFLAGS}"
+       export MPICHLIB_CXXFLAGS="${CXXFLAGS}"
+       export MPICHLIB_FFLAGS="${FFLAGS}"
+       export MPICHLIB_FCFLAGS="${FCFLAGS}"
+       export MPICHLIB_LDFLAGS="${LDFLAGS}"
+
+       # Dropped w/ bug #725842 fix
+       #unset CFLAGS CPPFLAGS CXXFLAGS FFLAGS FCFLAGS LDFLAGS
+
+       # Forcing Bash as there's quite a few bashisms in the build system
+       #
+       # Note that --with-device=ch3 is preserving the old 3.3.x default
+       # - keeping it for compatibility for now.
+       CONFIG_SHELL="${BROOT}/bin/bash" ECONF_SOURCE=${S} econf \
+               --enable-shared \
+               --with-hwloc-prefix="${EPREFIX}/usr" \
+               --with-hwloc-libdir="$(get_libdir)" \
+               --with-common-libdir="$(get_libdir)" \
+               --with-prefix-libdir="$(get_libdir)" \
+               --with-izem-libdir="$(get_libdir)" \
+               --with-fiprovider-libdir="$(get_libdir)" \
+               ${c} \
+               --with-pm=hydra \
+               --without-ze \
+               --with-device=ch3 \
+               --disable-fast \
+               --enable-versioning \
+               $(use_enable romio) \
+               $(use_enable cxx) \
+               $(use_enable fortran fortran all)
+}
+
+multilib_src_test() {
+       emake -j1 check
+}
+
+multilib_src_install() {
+       default
+
+       # fortran header cannot be wrapped (bug #540508), workaround part 1
+       if  use fortran; then
+               if multilib_is_native_abi; then
+                       mkdir "${T}"/fortran || die
+                       mv "${ED}"/usr/include/mpif* "${T}"/fortran || die
+                       mv "${ED}"/usr/include/*.mod "${T}"/fortran || die
+               else
+                       rm "${ED}"/usr/include/mpif* "${ED}"/usr/include/*.mod 
|| die
+               fi
+       fi
+}
+
+multilib_src_install_all() {
+       # Fortran header cannot be wrapped (bug #540508), workaround part 2
+       if use fortran; then
+               mv "${T}"/fortran/* "${ED}"/usr/include || die
+       fi
+
+       einstalldocs
+       newdoc src/pm/hydra/README README.hydra
+       if use romio; then
+               newdoc src/mpi/romio/README README.romio
+       fi
+
+       if ! use doc; then
+               rm -rf "${ED}"/usr/share/doc/${PF}/www* || die
+       fi
+}

Reply via email to